<?php
/**
 * @package            Joomla
 * @subpackage         Event Booking
 * @author             Tuan Pham Ngoc
 * @copyright          Copyright (C) 2010 - 2024 Ossolution Team
 * @license            GNU/GPL, see LICENSE.php
 */

defined('_JEXEC') or die;

use Joomla\CMS\Factory;
use Joomla\CMS\Plugin\CMSPlugin;

class plgEventbookingOnlyonevent extends CMSPlugin
{
	/**
	 * Database object.
	 *
	 * @var    JDatabaseDriver
	 */
	protected $db;

	/**
	 * Check accept registration
	 *
	 * @param   EventbookingTableEvent  $event
	 *
	 * @return bool
	 */
	public function onEBCheckAcceptRegistration($event): bool
	{
		$user = Factory::getUser();

		// In case user logged in
		if ($user->id)
		{
			$db    = $this->db;
			$query = $db->getQuery(true)
				->select('COUNT(*)')
				->from('#__eb_registrants')
				->where('(user_id = ' . $user->id . ' OR email = ' . $db->quote($user->email) . ')')
				->where('group_id = 0')
				->where('(published = 1 OR (published = 0 and payment_method LIKE "os_offline%"))');
			$db->setQuery($query);
			$numberRegisteredEvents = $db->loadResult();

			// The user has registered for at least one event
			if ($numberRegisteredEvents > 0)
			{
				$event->cannot_register_reason = 'user_registered_for_atleast_one_event';

				return false;
			}
		}

		return true;
	}
}
